
def rgb( r, g, b ):
	return 65536 * int( r * 255 ) + 256 * int( g * 255 ) + int( b * 255 )

def RGB( R, G, B ):
	return 65536 * R + 256 * G + B

def setpos( shape, x, y, w = None, h = None ):
	if w is not None:
		size = shape.Size
		size.Width, size.Height = w, h
		shape.Size = size
	position = shape.Position
	position.X, position.Y = x, y
	shape.Position = position

def createShape( model, page, shapetype, color = None ):
	shape = model.createInstance( 'com.sun.star.drawing.%sShape'%shapetype )
	page.add( shape )
	if color is not None:
		shape.FillStyle = 'SOLID'
		shape.FillColor = color
	elif hasattr( shape, 'FillStyle' ):
		shape.FillStyle = 'NONE'
	return shape

def createPolygon( model, page, coordss, color = None ):
	shape = createShape( model, page, 'PolyPolygon', color )

	from com.sun.star.awt import Point
	lines = []
	for coords in coordss:
		line = []
		for x, y in coords:
			p = Point()
			p.X = x
			p.Y = -y
			line.append( p )
		lines.append( tuple( line ) )
	shape.PolyPolygon = tuple( lines )
	return shape

